module NumLink                          
  implicit none
  integer, parameter :: N=10    
  ! 
  type :: link
    integer :: num                      ! 
    type(link), pointer :: next         ! ָһָ
  end type link

  type(link), target  :: linking(N) ! hashing
  type(link), pointer :: proc      ! ʱʹõָ

  integer :: Source(N) = (/ 21,53,71,19,61,81,3,17,44,93 /)

contains
  subroutine InitLink()
    integer i
	do i=1,N
	  linking(i)%num = 0
	  nullify(linking(i)%next)
	end do
  end subroutine

! hash
  integer function hash(KEY)
    integer KEY
    hash = KEY/10+1
	return
  end function
!
! ־ɢдӳ
!
  subroutine Insert(KEY, INFO)
    integer :: KEY, INFO ! ҪּSourceеλ
    integer :: L         ! hashing Ľ

    L=hash(KEY)        
    proc=>linking(L) ! procָlinkinghash(L)λ

    ! ƶеһλ
    do while( proc%num /= 0 )
      proc=>proc%next
    end do

    proc%num = INFO
    !ڴռproc%next
    allocate(proc%next)
	proc=>proc%next
    proc%num = 0
	nullify(proc%next)
  end subroutine Insert 
!
! вݵӳ
!
  subroutine Hash_Search( KEY )
    integer :: KEY  ! Ҫҵֵ
    integer :: L    ! hashingֵ

    L=hash(KEY)
    proc=>linking(L)        ! procָlinkinghash(L)λ

    ! һһֱ˳ҵҵΪֹ
    do while( .true. )
	  if ( proc%num==0 ) then
	    write(*,*) "Not found."
		return
	  end if
	  if ( Source(proc%num)==KEY ) then
	    write(*,"('Source(',I2,' )=',I3)") proc%num, KEY
		return
	  end if
	  if ( associated(proc%next) ) proc=>proc%next
    end do
    return
  end subroutine Hash_Search
!
! ݵӳ
!
  subroutine OutputLink()
    integer :: i 
    do i=1,N
      proc=>linking(i)
      write(*,"(1X,I2,':')", advance="NO") i
      do while( associated(proc%next) )
        write(*,"('->',I2)", advance="NO" ) Source(proc%num)
        proc=>proc%next
      end do
      write(*,*)
    end do
  end subroutine OutputLink

end module NumLink
!       
!    ϡҷ
!                  
program HASHING_SEARCH_DEMO
use NumLink
implicit none
  integer :: KEY  ! ¼Ҫҵֵ
  integer :: I    ! ѭ

  call InitLink()
  write(*,"('Source=>',10I3)") Source
  do I=1,N
    call Insert( Source(I), I )
  end do
  write(*,*) 'Link List=>'
  call OutputLink()
! Ҫҵֵ
  write(*,*) 'Input KEY:'
  read (*,*) KEY
! ˳ҵӳ
  call Hash_Search(KEY)
  stop
end program HASHING_SEARCH_DEMO
